import numpy as np
import numpy.polynomial.polynomial as nppol# pour le polynme
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker # pour le format des tiquettes en x (remplacer le point dcimal par la virgule)

# Paramtres acido-basiques
pKa1=12
pKa2=8.5
pKa3=5
Ke=1e-14# produit ionique de l'eau
Ca = 0.12
Cb = 0.15
Va = 10.0
Vbmax=25
#------------------------------------------------------------
# valeurs dduites des paramtres :
Ka1=10**(-pKa1)
Ka2=10**(-pKa2)
Ka3=10**(-pKa3)
Kb1=Ke/Ka1
Kb2=Ke/Ka2
Kb3=Ke/Ka3
Vbmin=0
volume = np.linspace(Vbmin, Vbmax, 256,endpoint=True)

#------------------------------------------------------------
#rglage perso de la grille secondaire du graphe :
# fig = plt.figure(figsize=(29.7/2.54,21/2.54))#format A4 paysage
fig = plt.figure(figsize=(21/2.54,14.8/2.54))#c format A5 paysage
ax = fig.add_subplot(1, 1, 1)
minor_xticks = np.arange(0, 101, 1)#espaces de la grille
minor_yticks = np.arange(0, 101, 0.2)#espaces de la grille
ax.set_xticks(minor_xticks, minor=True)
ax.set_yticks(minor_yticks, minor=True)
ax.grid(which='minor', alpha=0.2)

def concentration(Vb):#Calcule [H3O+]
    # 1, a, b, c, d, e : les coefficients du polynme de degr 5
    a=Kb1+Cb*Vb/(Vb+Va)
    b= Ke+Kb1*(Ca*Va-Cb*Vb)/(Vb+Va)-Kb1*Kb2
    c=Kb1*Ke+Kb1*Kb2*(2*Ca*Va-Cb*Vb)/(Va+Vb)
    d=Kb1*Kb2*Kb3*(3*Ca*Va-Cb*Vb)/(Va+Vb)
    e=Kb1*Kb2*Kb3*Ke
    vm = nppol.polyroots([-e, -d,-c,-b,a,1])#chercher les racines du polynme
    positive=filter(lambda x: x>0,filter(np.isreal,vm))
    C=next(positive)
    return C

def titrage(Vmin,Vmax):# calcul du pH
    ph=14+np.log10(np.vectorize(concentration)(volume))
    return volume,ph

#---------------------------remplacer  les points dcimaux par des virgules :
def func(x, pos):  # formatter function takes tick label and tick position
    s = str(x)
    ind = s.index('.')
    return s[:ind] + ',' + s[ind+1:]   # change dot to comma
x_format = ticker.FuncFormatter(func)  # make formatter
#----------------------------------------------------------------------------------------------------------

def graphique_ph():
    volume,ph=titrage(Vbmin,Vbmax)
    plt.plot(volume, ph)

plt.title("Titrage pH-mtrique d'une tribase")
plt.xlabel(r"Volume $V_b$ d'acide vers (mL)")
plt.ylabel("pH", loc='top', rotation=0)
plt.grid()
plt.axis([0, Vbmax, 0, 14])#limites des axes
plt.yticks(np.arange(0, 14, 1))# ajuster l'espace entre valeurs axe y
plt.xticks(np.arange(0, Vbmax, 2.0))# ajuster l'espace entre valeurs axe x
#    ax.xaxis.set_major_formatter(x_format)  # appliquer le format de virgule dcimale

graphique_ph()

fig.savefig('Titrage_tribasee.png', dpi=200)# Cration image PNG (adapter la rsolution au rsultat souhait)
fig.savefig('Titrage_tribase.pdf', dpi=200)# Cration PDF

# plt.show()